<?php

class safebill{
var $title, $description, $enabled, $mode, $wsdl_url,$validation_type, $order_statuses;

function safebill(){
	global $order;
    
    $this->enabled = ((MODULE_PAYMENT_SAFEBILLOSC_STATUS == 'True') ? true : false);
	$this->sort_order = MODULE_PAYMENT_SAFEBILLOSC_SORT_ORDER;
    $this->email_footer = MODULE_PAYMENT_SAFEBILLOSC_TEXT_EMAIL_FOOTER;
	$this->mode = MODULE_PAYMENT_SAFEBILLOSC_MODE;
	$this->validation_type = MODULE_PAYMENT_SAFEBILLOSC_VALIDATION_TYPE;
	$this->products_ordered = '';
	$this->products_ordered_attributes = '';
	$this->payment_surcharge_percent = MODULE_PAYMENT_SAFEBILLOSC_SURCHARGE_PERCENT;
	$this->payment_surcharge_amount = MODULE_PAYMENT_SAFEBILLOSC_SURCHARGE_AMOUNT;
	$this->merchant = array(
				'id' => MODULE_PAYMENT_SAFEBILLOSC_ID,
				'pwd' => MODULE_PAYMENT_SAFEBILLOSC_PASSWD,
				'success_url' => MODULE_PAYMENT_SAFEBILLOSC_SUCCESS_URL,
				'cancel_url' => MODULE_PAYMENT_SAFEBILLOSC_CANCEL_URL,
				'error_url' => MODULE_PAYMENT_SAFEBILLOSC_ERROR_URL);
	
	if($this->mode == 'Test'){
		$this->wsdl_url = 'http://request.swissbilling.ch/EShopRequest.wsdl';
	}else{
		$this->wsdl_url = 'https://secure.safebill.ch:9903/EShopRequestSec.wsdl';
	}
	
	$this->client = new SoapClient($this->wsdl_url, array( "trace" => 0, "exceptions" => 1));


}//End function



function check_status(){
	if(defined('MODULE_PAYMENT_SAFEBILLOSC_STATUS') && $this->enabled){
		return true;
	}else{
		return false;
	}
}//End function

function set_sb_operation($acknowledge_flag,$cancel_flag,$order_id,$order_status_history_id){
	$operation_status = array();
	$order_date_query = tep_db_query("SELECT date_purchased FROM " . TABLE_ORDERS . " WHERE orders_id=" . (int)$order_id);
	$order_date = tep_db_fetch_array($order_date_query);
	
	if($acknowledge_flag == 1){
		
		try{
			$resp = $this->client->EshopTransactionAcknowledge($this->merchant,$order_id,$order_date['date_purchased']);
			
			$operation_status['aknowledge']['status'] = 'success';
			$operation_status['aknowledge']['message'] = 'Acknowledgement done with success';
		}catch(SoapFault $e){
			$operation_status['aknowledge']['status'] = 'error';
			$operation_status['aknowledge']['message'] = 'Acknowledgement error:' . addslashes($e);
					
		}
		
		$update_acknowledge = tep_db_query("UPDATE " . TABLE_ORDERS_STATUS_HISTORY . " SET sb_return_status='" .$operation_status['aknowledge']['message']. "' WHERE orders_status_history_id=" . (int)$order_status_history_id);
	}
	
	if($cancel_flag == 1){
		try{
			$resp = $this->client->EshopTransactionCancel($this->merchant,$order_id,$order_date['date_purchased']);
			
			if($resp->status == 'Canceled by merchant'){
				$operation_status['cancel']['status'] = 'success';
				$operation_status['cancel']['message'] = 'Safebill Cancel done with success';
			}else{
				$operation_status['cancel']['status'] = 'warning';
				$operation_status['cancel']['message'] = 'Problem on Safebill Cancel. Status returned:' . $resp->status;
			}
			
		}catch(SoapFault $e){
			$operation_status['cancel']['status'] = 'error';
			$operation_status['cancel']['message'] = 'Safebill Cancel error:' . addslashes($e);
		
		}
		
		$update_cancel = tep_db_query("UPDATE " . TABLE_ORDERS_STATUS_HISTORY . " SET sb_return_status='" .$operation_status['cancel']['message']. "' WHERE orders_history_id=" . $order_status_history_id);
	}
	
	
	
	if(sizeof($operation_status) > 0){
		return $operation_status;
	}else{
		return false;
	}

}//End function



}//End class
?>