<?php
/*
  $Id: ot_shipping.php 1739 2007-12-20 00:52:16Z hpdl $

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2007 osCommerce

  Released under the GNU General Public License
*/

  class ot_payment_surcharge {
    var $title, $output;

    function ot_payment_surcharge() {
      $this->code = 'ot_payment_surcharge';
      $this->title = MODULE_ORDER_TOTAL_PAYMENT_SURCHARGE_TITLE;
      $this->description = MODULE_ORDER_TOTAL_PAYMENT_SURCHARGE_DESCRIPTION;
	  $this->tax_class = MODULE_PAYMENT_SURCHARGE_TAX_CLASS;
      $this->enabled = ((MODULE_ORDER_TOTAL_PAYMENT_SURCHARGE_STATUS == 'true') ? true : false);
      $this->sort_order = MODULE_ORDER_TOTAL_PAYMENT_SURCHARGE_SORT_ORDER;

      $this->output = array();
    }

    function process() {
      global $order, $currencies;
		$module = $GLOBALS['payment'];
	
      if (tep_not_null($order->info['payment_method'])) {
        if ($this->tax_class != 0) {
          $payment_surcharge_tax = tep_get_tax_rate($this->tax_class, $order->delivery['country']['id'], $order->delivery['zone_id']);
          $payment_tax_description = tep_get_tax_description($this->tax_class, $order->delivery['country']['id'], $order->delivery['zone_id']);
		  
		  $payment_surcharge_amount = ($this->calculate_subtotal_ht($order->products,$order->info['shipping_cost']) * ($GLOBALS[$module]->payment_surcharge_percent/100)) + $GLOBALS[$module]->payment_surcharge_amount;
			
          $order->info['tax'] += tep_calculate_tax($payment_surcharge_amount, $payment_surcharge_tax);
          $order->info['tax_groups'][$payment_tax_description] += tep_calculate_tax($payment_surcharge_amount, $payment_surcharge_tax);
          $order->info['total'] += $payment_surcharge_amount + tep_calculate_tax($payment_surcharge_amount, $payment_surcharge_tax);

          if (DISPLAY_PRICE_WITH_TAX == 'true') $payment_surcharge_amount += tep_calculate_tax($payment_surcharge_amount, $payment_surcharge_tax);
        }

        $this->output[] = array('title' => MODULE_ORDER_TOTAL_PAYMENT_SURCHARGE_TITLE . ':',
                                'text' => $currencies->format($payment_surcharge_amount, true, $order->info['currency'], $order->info['currency_value']),
                                'value' => $payment_surcharge_amount);
		
      }
    }
	
	function calculate_subtotal_ht($products, $shipping_cost){
		$subtotal = 0;
		foreach($products as $key => $val){
			$subtotal += $val['final_price'];
		}	
		$subtotal += $shipping_cost;
		
		return $subtotal;
	}

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_ORDER_TOTAL_PAYMENT_SURCHARGE_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }

      return $this->_check;
    }

    function keys() {
      return array('MODULE_ORDER_TOTAL_PAYMENT_SURCHARGE_STATUS', 'MODULE_ORDER_TOTAL_PAYMENT_SURCHARGE_SORT_ORDER', 'MODULE_PAYMENT_SURCHARGE_TAX_CLASS');
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Display Payment Surcharge', 'MODULE_ORDER_TOTAL_PAYMENT_SURCHARGE_STATUS', 'true', 'Do you want to dispay the payment surcharge?', '6', '1','tep_cfg_select_option(array(\'true\', \'false\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_ORDER_TOTAL_PAYMENT_SURCHARGE_SORT_ORDER', '0', 'Sort order of display.', '6', '2', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Tax Class', 'MODULE_PAYMENT_SURCHARGE_TAX_CLASS', '0', 'Use the following tax class on the payment surcharge.', '6', '0', 'tep_get_tax_class_title', 'tep_cfg_pull_down_tax_classes(', now())");
    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }
  }
?>
