<?php
/* -----------------------------------------------------------------------------------------
   $Id: safebillosc.php 1308 2010-10-26 14:22:18Z af $

   Copyright (c) 2010 salesconquest.com
   -----------------------------------------------------------------------------------------

   Released under the GNU General Public License
   ---------------------------------------------------------------------------------------*/

class safebillosc {
	var $code, $title, $description, $enabled, $email_footer, $form_action_url,$order_status,$payment_status,$mode, $wsdl_url,$validation_type, $order_statuses, $products_ordered, $products_ordered_attributes;

  function safebillosc() {
	global $order;
    $this->code = 'safebillosc';
    $this->title = MODULE_PAYMENT_SAFEBILLOSC_TEXT_TITLE;
    $this->description = MODULE_PAYMENT_SAFEBILLOSC_TEXT_DESCRIPTION;
    $this->enabled = ((MODULE_PAYMENT_SAFEBILLOSC_STATUS == 'True') ? true : false);
	$this->sort_order = MODULE_PAYMENT_SAFEBILLOSC_SORT_ORDER;
    $this->email_footer = MODULE_PAYMENT_SAFEBILLOSC_TEXT_EMAIL_FOOTER;
	$this->mode = MODULE_PAYMENT_SAFEBILLOSC_MODE;
	$this->validation_type = MODULE_PAYMENT_SAFEBILLOSC_VALIDATION_TYPE;
	$this->products_ordered = '';
	$this->products_ordered_attributes = '';
	$this->payment_surcharge_percent = MODULE_PAYMENT_SAFEBILLOSC_SURCHARGE_PERCENT;
	$this->payment_surcharge_amount = MODULE_PAYMENT_SAFEBILLOSC_SURCHARGE_AMOUNT;
	
	
	//Change the ID value with the one of your order_status_id
	$this->safebill_order_statuses = array('Cancel' => 5,
										   'Failed' => 6,
										   'Open' => 7,
										   'Completed' => 8);
	//$this->payment_surcharge = MODULE_PAYMENT_SMALLPAY_ADDITIONAL_AMOUNT;
	
	if ((int)MODULE_PAYMENT_SAFEBILLOSC_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_SAFEBILLOSC_ORDER_STATUS_ID;
    }
	if (is_object($order)) $this->update_status();
	if($this->mode == 'Test'){
		$this->wsdl_url = 'http://request.swissbilling.ch/EShopRequest.wsdl';
	}else{
		$this->wsdl_url = 'https://secure.safebill.ch:9903/EShopRequestSec.wsdl';
	}
	
	//$this->client = new SoapClient($this->wsdl_url, array( "trace" => 0, "exceptions" => 1));
  }
  
  function get_payment_surcharge(){
		return $this->payment_surcharge;
	}
  
  function update_status() {
      global $order;

      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_SAFEBILLOSC_ZONE > 0) ) {
        $check_flag = false;
        $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_SAFEBILLOSC_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
        while ($check = tep_db_fetch_array($check_query)) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->billing['zone_id']) {
            $check_flag = true;
            break;
          }
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
	  
    }
  
  function setSha($amount,$currency){
	$str_hash = sha1($_SESSION['insert_id'] . $amount . $currency . MODULE_PAYMENT_SAFEBILLOSC_ID . MODULE_PAYMENT_SAFEBILLOSC_SHASIGN);
	return $str_hash;
  }

  function javascript_validation() {
    return false;
  }

  function selection() {
    return array('id' => $this->code, 'module' => $this->title . sprintf($this->description,MODULE_PAYMENT_SAFEBILLOSC_ADDITIONAL_AMOUNT));
  }

 
function pre_confirmation_check() {
  return false;
}


  function confirmation() {
    return false;
  }

  function process_button() {
    return false;
  }
  
  function get_language_code(){
	$lang_query = tep_db_query("SELECT code FROM " . TABLE_LANGUAGES. " WHERE languages_id=" . (int)$_SESSION['languages_id']);
	$lang_code = tep_db_fetch_array($lang_query);
	return $lang_code['code'];
  }
  
  function get_gender($address_type = 'billto'){
	$gender_query = tep_db_query("SELECT entry_gender FROM " . TABLE_ADDRESS_BOOK. " WHERE address_book_id=" . (int)$_SESSION[$address_type]);
	$gender = tep_db_fetch_array($gender_query);
	return $gender['entry_gender'];
  }
  
  function cart_items($item_tab){
	global $currencies;
	$has_tax = true;
	$key = 0;
		
	foreach ($item_tab as $k => $v) {
		$tax_query = tep_db_query("SELECT products_tax_class_id FROM " . TABLE_PRODUCTS . " WHERE products_id = " . (int)tep_get_prid($v['id']));
		$tax = tep_db_fetch_array($tax_query);
		if($tax['products_tax_class_id'] == 0){
			$has_tax = false;
			break;
		}
		$key++;
	}
	$key = 0;
	foreach($item_tab as $kk => $vv){
		if(!$has_tax){
			//No tax defined
			$items[$key]['short_desc'] = $vv['name'];
			$items[$key]['quantity'] = $vv['qty'];
			$items[$key]['unit_price'] = $vv['final_price'];//Unit price
			$items[$key]['VAT_rate'] = 0;
			$items[$key]['VAT_amount'] = 0;
		}else{
			//Calculate tax amount
			$tax_amount = $currencies->calculate_price($vv['final_price'],$vv['tax']) - $vv['final_price'];
			$items[$key]['short_desc'] = $vv['name'];
			$items[$key]['quantity'] = $vv['qty'];
			//$items[$key]['unit_price'] = (fn_safebill_price_with_tax($vv['product_id'])=='Y' ? $vv['price']-$vv['tax_value']: $vv['price']);
			$items[$key]['unit_price'] = $currencies->calculate_price($vv['final_price'],$vv['tax']);//Unit price TTC
			$items[$key]['VAT_rate'] = $vv['tax'];
			$items[$key]['VAT_amount'] = tep_round($tax_amount,2);
		}
		$key++;
	}
	
	return $items;
  }

  function before_process() {
	global $lng, $customer_id, $languages_id, $order, $order_totals,$cart;
	//p($_SESSION);die;
	
	
	$merchant = array(
				'id' => MODULE_PAYMENT_SAFEBILLOSC_ID,
				'pwd' => MODULE_PAYMENT_SAFEBILLOSC_PASSWD,
				'success_url' => MODULE_PAYMENT_SAFEBILLOSC_SUCCESS_URL,
				'cancel_url' => MODULE_PAYMENT_SAFEBILLOSC_CANCEL_URL,
				'error_url' => MODULE_PAYMENT_SAFEBILLOSC_ERROR_URL);
	
        if(!isset($_GET['notify'])){
			//Go to Safebill
			$this->add_order();
			$admin_fee_amount = '0.00';
			foreach($order_totals as $key => $val){
				if($val['code'] == 'ot_payment_surcharge'){
					$admin_fee_amount = tep_round($val['value'],2);
					break;
				}
			}
			$transaction = array(
				'type' => MODULE_PAYMENT_SAFEBILLOSC_MODE,
				'is_B2B' => 0,
				'eshop_ID' => MODULE_PAYMENT_SAFEBILLOSC_SHOP_ID,
				'eshop_ref' => $_SESSION['insert_id'],
				'order_timestamp' => date('Y-m-d H:i:s'),
				'currency' => 'CHF',
				'amount' => $order->info['total'], //montant TTC
				'VAT_amount' => tep_round($order->info['tax'],2), // Total tax 7.6 + tax 2.4
				'admin_fee_amount' => $admin_fee_amount, //Payment method surcharge
				'delivery_fee_amount' => $order->info['shipping_cost'],
				'coupon_discount_amount' => '0.00', // Coupon amount discount here
				'vol_discount' => '0.00', //Add quantity discont amount here
				'phys_delivery' => true,
				'delivery_status' => (MODULE_PAYMENT_SAFEBILLOSC_VALIDATION_TYPE=='auto' ? 'distributed' : 'pending'),
				'debtor_IP' => $_SERVER['REMOTE_ADDR']
				//'signature' => sha1(MODULE_PAYMENT_SAFEBILLOSC_ID . $_SESSION['order_id'] . $total_amount . MODULE_PAYMENT_SAFEBILLOSC_SHASIGN),
			);
			
			$items = $this->cart_items($order->products);
			
			$debtor = array(
				//'user_ID' => $order_info['user_id'],
				'company_name' => $order->billing['company'],
				'title'  => $this->get_gender(),
				'firstname'  => $order->billing['firstname'],
				'lastname'  => $order->billing['lastname'],
				'birthdate'  => '',
				'adr1'  => $order->billing['street_address'],
				'adr2'  => $order->billing['suburb'],
				'city'  => $order->billing['city'],
				'country' => $order->billing['country']['iso_code_2'],
				'zip'  => $order->billing['postcode'],
				'email'  => $order->customer['email_address'],
				'phone' => $order->customer['telephone'],
				'language'  => $this->get_language_code()
			);
			
			//Prevent anonymous order
			if($customer_id != 0 || !empty($customer_id)){
				$debtor['user_ID'] = $customer_id;
			}
			
			if($_SESSION['sendto'] != $_SESSION['billto']){
				$debtor['deliv_title'] = $this->get_gender('sendto');
				$debtor['deliv_firstname'] = $order->delivery['firstname'];
				$debtor['deliv_lastname'] = $order->delivery['lastname'];
				$debtor['deliv_adr1'] = $order->delivery['street_address'];
				$debtor['deliv_adr2'] = $order->delivery['suburb'];
				$debtor['deliv_city'] = $order->delivery['city'];
				$debtor['deliv_zip'] = $order->delivery['postcode'];
				$debtor['deliv_country'] = $order->delivery['country']['iso_code_2'];
			}
			
			/*$client = new nusoap_client($this->wsdl_url, 'wsdl');
			$err = $client->getError();
			if ($err) {
				$error = '<pre>' . $err . '</pre>';
				tep_db_query("INSERT INTO " . TABLE_SAFEBILL_PAYMENT_RESULTS . " SET orders_id=".$_SESSION['insert_id'].",result = '".addslashes($error)."'");
				tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, 'payment_error=' . $this->code . '&error=' . urlencode(MODULE_PAYMENT_SAFEBILLOSC_TEXT_ORDER_ERROR), 'SSL', true, false));
				exit();
			}else{
				$client->soap_defencoding = 'UTF-8';
				$client->decode_utf8 = false;
				$params = array('merchant' => $merchant,'transaction' => $transaction, 'debtor' => $debtor,'count'=> count($items),'items' => $items);
				$result = $client->call('EshopTransactionRequest', $params);
				if ($client->fault) {
					tep_db_query("INSERT INTO " . TABLE_SAFEBILL_PAYMENT_RESULTS . " SET orders_id=".$_SESSION['insert_id'].",result = '".addslashes($result)."'");
				tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, 'payment_error=' . $this->code . '&error=' . urlencode(MODULE_PAYMENT_SAFEBILLOSC_TEXT_ORDER_ERROR), 'SSL', true, false));
					exit();
				} else {
						tep_redirect($result['url']);
					exit;
				}
			}*/
			
			
			try {
				$client = new SoapClient($this->wsdl_url, array( "trace" => 0, "exceptions" => 1));
				
				$status = $client->EshopTransactionRequest($merchant, $transaction, $debtor, count($items), $items);
				$return_url = $status->url;
				//In case of internal error to SB
				if($status->status == 'Failed'){
					$return_url .= '&status=Failed&notify=true';
				}
					
				
				tep_redirect($return_url);
				exit;
			}catch (SoapFault $exception) {
				tep_db_query("INSERT INTO " . TABLE_SAFEBILL_PAYMENT_RESULTS . " SET orders_id=".$_SESSION['insert_id'].",result = '".addslashes($exception)."'");
				tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, 'payment_error=' . $this->code . '&error=' . urlencode(MODULE_PAYMENT_SAFEBILLOSC_TEXT_ORDER_ERROR), 'SSL', true, false));
			}
		}else{
			//Back from Safebill
			$success = false;
			//Finalizing order and notification
			$order_id = $_GET['trans'];
			if($order_id = $_SESSION['insert_id']){
				try {
					$client = new SoapClient($this->wsdl_url, array( "trace" => 0, "exceptions" => 1));
					$response = $client->EshopTransactionStatusRequest($merchant, $order_id, $_REQUEST['timestamp']);
					//fn_print_r($_SESSION);
					//p($response);
					//print("<pre>Transaction id=".$order_id." - Acknowledged</pre>");
					
					if(isset($response->sbmember_id) && $response->sbmember_id > 0){
						tep_db_query("UPDATE " . TABLE_CUSTOMERS . " SET sb_user_id =".(int)$response->sbmember_id." WHERE user_id =" . $_SESSION['customer_id']);
					}
				
					$res['transaction_id'] = $response->transaction_id;
					$res['status'] = $response->status;
					$res['url'] = $response->url;
					$res['merchantmsg'] = $response->merchantmsg;
					$res['debtormsg'] = $response->debtormsg;
					$res['partial_payment'] = $response->partial_payment;
					$res['invoicing_costs'] = $response->invoicing_costs;
					$res['partial_payment_fees'] = $response->partial_payment_fees;
					$res['partial_payment_rate'] = $response->partial_payment_rate;
					$res['partial_payment_table'] = $response->partial_payment_table;
					$res['sbmember_id'] = $response->sbmember_id;
					$string = '';
					//fn_print_die($_REQUEST); die;
					$i=1;
					foreach ($res as $key => $val) {
						$string .= $key . ' = ' . $val;
						if($i < sizeof($res)){
							$string.= ',';
						}
						$i++;
					}
				
					tep_db_query("INSERT INTO " . TABLE_SAFEBILL_PAYMENT_RESULTS . " SET orders_id=$order_id,result = '$string'");
				
					if (!empty($res['partial_payment_fees'])) {
						tep_db_query("UPDATE " . TABLE_ORDERS . " SET sb_partial_payment_fees = " .$res['partial_payment_fees']. " WHERE orders_id = " . (int)$_SESSION['insert_id']);
					}
				
					if (!empty($res['invoicing_costs'])) {
						tep_db_query("UPDATE " . TABLE_ORDERS . " SET sb_invoicing_costs = " .$res['invoicing_costs']. " WHERE orders_id = " . (int)$_SESSION['insert_id']);
					}
				
					unset($data);
					if ($res['partial_payment'] == 1) {
						
						for($i=0;$i<sizeof($res['partial_payment_table']); $i++){
							$data['orders_id'] = $_SESSION['insert_id'];
							$data['date'] = date("d-m-Y",strtotime($res['partial_payment_table'][$i]->date));
							$data['amount'] = $res['partial_payment_table'][$i]->amount;
							$data['timestamp'] = strtotime($res['partial_payment_table'][$i]->date);
							tep_db_perform(TABLE_SAFEBILL_PARTIAL_PAYMENT_TABLE, $data);
						}
					}
				
					if ($res['status'] == 'Canceled by merchant' || $res['status'] == 'Canceled by user' || $res['status'] == 'Canceled') {
						//Status Cancel
						$pp_response['order_status'] = $this->safebill_order_statuses['Cancel'];
						$pp_response['reason_text'] = $_REQUEST['status'];
						$pp_response['redirect'] = FILENAME_CHECKOUT_PAYMENT;
						$pp_response['params'] = 'payment_error=' . $this->code . '&error=' . urlencode(MODULE_PAYMENT_SAFEBILLOSC_TEXT_ORDER_CANCEL);
						$pp_response['send_email'] = 'N';
					} elseif ($res['status'] == 'Failed' || $res['status'] == 'Timed Out') {
						//Status Failed
						$pp_response['order_status'] = $this->safebill_order_statuses['Failed'];
						$pp_response['reason_text'] = $res['reason_text'];
						$pp_response['redirect'] = FILENAME_CHECKOUT_PAYMENT;
						$pp_response['params'] = 'payment_error=' . $this->code . '&error=' . urlencode(MODULE_PAYMENT_SAFEBILLOSC_TEXT_ORDER_ERROR);
						$pp_response['send_email'] = 'N';
					} else {
						//Check the validation type: 'auto' or 'manual'
						if($this->validation_type == 'auto'){
							$success = true;
							//Status Processing
							$pp_response['order_status'] = $this->safebill_order_statuses['Completed'];
							$pp_response['redirect'] = FILENAME_CHECKOUT_SUCCESS;
							$pp_response['params'] = '';
							$pp_response['send_email'] = 'Y';
						  try {
							$client = new SoapClient($this->wsdl_url, array( "trace" => 0, "exceptions" => 1));
							$client->EshopTransactionAcknowledge($merchant, $_SESSION['insert_id'], $_REQUEST['timestamp']); 	
							
						  } catch (SoapFault $exception) { 
							tep_db_query("INSERT INTO " . TABLE_SAFEBILL_PAYMENT_RESULTS . " SET orders_id=$order_id,result = '".addslashes($exception)."'");
							tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, 'payment_error=' . $this->code . '&error=' . urlencode(MODULE_PAYMENT_SAFEBILLOSC_TEXT_ORDER_ERROR), 'SSL', true, false));
							exit;
						  }
						}else{
							$success = true;
							//Status Pending
							$pp_response['order_status'] = $this->safebill_order_statuses['Open'];
							$pp_response['redirect'] = FILENAME_CHECKOUT_SUCCESS;
							$pp_response['send_email'] = 'Y';
							$pp_response['params'] = '';
						}
					}
					
					//Update order status
					$order_query = tep_db_query("UPDATE " . TABLE_ORDERS . " SET orders_status=" .(int)$pp_response['order_status']. " WHERE orders_id=" . (int)$_SESSION['insert_id']);
					$order_status_hist_query = tep_db_query("UPDATE " . TABLE_ORDERS_STATUS_HISTORY . " SET orders_status_id=" .(int)$pp_response['order_status']. " WHERE orders_id=" . (int)$_SESSION['insert_id']);
					
					if($pp_response['send_email'] == 'Y'){
						$this->send_order_email($order_totals);
					}
					
					if($success){
					   $cart->reset(true);
					// unregister session variables used during checkout
					  tep_session_unregister('sendto');
					  tep_session_unregister('billto');
					  tep_session_unregister('shipping');
					  tep_session_unregister('payment');
					  tep_session_unregister('comments');
					  tep_session_unregister('products_ordered');
					  tep_session_unregister('insert_id');
					}
					//tep_redirect(tep_href_link($pp_response['redirect'], '', 'SSL'));
					tep_redirect(tep_href_link($pp_response['redirect'], $pp_response['params'], 'SSL', true, false));
					exit;
				} catch (SoapFault $exception) { 
					
					tep_db_query("INSERT INTO " . TABLE_SAFEBILL_PAYMENT_RESULTS . " SET orders_id=$order_id,result = '$exception'");
					$pp_response['order_status'] = $this->safebill_order_statuses['Failed'];
					$pp_response['redirect'] = 'checkout_success.php';
					$pp_response['send_email'] = 'N';
					$pp_response['params'] = 'payment_error=' . $this->code . '&error=' . urlencode(MODULE_PAYMENT_SAFEBILLOSC_TEXT_ORDER_ERROR);
					tep_redirect(tep_href_link($pp_response['redirect'], $pp_response['params'], 'SSL', true, false));
					exit;
				}
			
			}
		}
  }
  
  function add_order(){
	global $customer_id, $languages_id, $order, $order_totals, $currencies;
	
			$sql_data_array = array('customers_id' => $customer_id,
                          'customers_name' => $order->customer['firstname'] . ' ' . $order->customer['lastname'],
                          'customers_company' => $order->customer['company'],
                          'customers_street_address' => $order->customer['street_address'],
                          'customers_suburb' => $order->customer['suburb'],
                          'customers_city' => $order->customer['city'],
                          'customers_postcode' => $order->customer['postcode'], 
                          'customers_state' => $order->customer['state'], 
                          'customers_country' => $order->customer['country']['title'], 
                          'customers_telephone' => $order->customer['telephone'], 
                          'customers_email_address' => $order->customer['email_address'],
                          'customers_address_format_id' => $order->customer['format_id'], 
                          'delivery_name' => trim($order->delivery['firstname'] . ' ' . $order->delivery['lastname']),
                          'delivery_company' => $order->delivery['company'],
                          'delivery_street_address' => $order->delivery['street_address'], 
                          'delivery_suburb' => $order->delivery['suburb'], 
                          'delivery_city' => $order->delivery['city'], 
                          'delivery_postcode' => $order->delivery['postcode'], 
                          'delivery_state' => $order->delivery['state'], 
                          'delivery_country' => $order->delivery['country']['title'], 
                          'delivery_address_format_id' => $order->delivery['format_id'], 
                          'billing_name' => $order->billing['firstname'] . ' ' . $order->billing['lastname'], 
                          'billing_company' => $order->billing['company'],
                          'billing_street_address' => $order->billing['street_address'], 
                          'billing_suburb' => $order->billing['suburb'], 
                          'billing_city' => $order->billing['city'], 
                          'billing_postcode' => $order->billing['postcode'], 
                          'billing_state' => $order->billing['state'], 
                          'billing_country' => $order->billing['country']['title'], 
                          'billing_address_format_id' => $order->billing['format_id'], 
                          'payment_method' => $order->info['payment_method'], 
                          'cc_type' => $order->info['cc_type'], 
                          'cc_owner' => $order->info['cc_owner'], 
                          'cc_number' => $order->info['cc_number'], 
                          'cc_expires' => $order->info['cc_expires'], 
                          'date_purchased' => 'now()', 
                          'orders_status' => $order->info['order_status'], 
                          'currency' => $order->info['currency'], 
                          'currency_value' => $order->info['currency_value']);
			tep_db_perform(TABLE_ORDERS, $sql_data_array);
			$insert_id = tep_db_insert_id();
			$_SESSION['insert_id'] = $insert_id;
			for ($i=0, $n=sizeof($order_totals); $i<$n; $i++) {
			  $sql_data_array = array('orders_id' => $insert_id,
									  'title' => $order_totals[$i]['title'],
									  'text' => $order_totals[$i]['text'],
									  'value' => $order_totals[$i]['value'], 
									  'class' => $order_totals[$i]['code'], 
									  'sort_order' => $order_totals[$i]['sort_order']);
			  tep_db_perform(TABLE_ORDERS_TOTAL, $sql_data_array);
			}

			$customer_notification = (SEND_EMAILS == 'true') ? '1' : '0';
			$sql_data_array = array('orders_id' => $insert_id, 
									'orders_status_id' => $order->info['order_status'], 
									'date_added' => 'now()', 
									'customer_notified' => $customer_notification,
									'comments' => $order->info['comments']);
			tep_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);
		  
		  // initialized for the email confirmation
			//$products_ordered = '';
			$subtotal = 0;
			$total_tax = 0;

			for ($i=0, $n=sizeof($order->products); $i<$n; $i++) {
		  // Stock Update - Joao Correia
			  if (STOCK_LIMITED == 'true') {
				if (DOWNLOAD_ENABLED == 'true') {
				  $stock_query_raw = "SELECT products_quantity, pad.products_attributes_filename 
									  FROM " . TABLE_PRODUCTS . " p
									  LEFT JOIN " . TABLE_PRODUCTS_ATTRIBUTES . " pa
									   ON p.products_id=pa.products_id
									  LEFT JOIN " . TABLE_PRODUCTS_ATTRIBUTES_DOWNLOAD . " pad
									   ON pa.products_attributes_id=pad.products_attributes_id
									  WHERE p.products_id = '" . tep_get_prid($order->products[$i]['id']) . "'";
		  // Will work with only one option for downloadable products
		  // otherwise, we have to build the query dynamically with a loop
				  $products_attributes = $order->products[$i]['attributes'];
				  if (is_array($products_attributes)) {
					$stock_query_raw .= " AND pa.options_id = '" . $products_attributes[0]['option_id'] . "' AND pa.options_values_id = '" . $products_attributes[0]['value_id'] . "'";
				  }
				  $stock_query = tep_db_query($stock_query_raw);
				} else {
				  $stock_query = tep_db_query("select products_quantity from " . TABLE_PRODUCTS . " where products_id = '" . tep_get_prid($order->products[$i]['id']) . "'");
				}
				if (tep_db_num_rows($stock_query) > 0) {
				  $stock_values = tep_db_fetch_array($stock_query);
		  // do not decrement quantities if products_attributes_filename exists
				  if ((DOWNLOAD_ENABLED != 'true') || (!$stock_values['products_attributes_filename'])) {
					$stock_left = $stock_values['products_quantity'] - $order->products[$i]['qty'];
				  } else {
					$stock_left = $stock_values['products_quantity'];
				  }
				  tep_db_query("update " . TABLE_PRODUCTS . " set products_quantity = '" . $stock_left . "' where products_id = '" . tep_get_prid($order->products[$i]['id']) . "'");
				  if ( ($stock_left < 1) && (STOCK_ALLOW_CHECKOUT == 'false') ) {
					tep_db_query("update " . TABLE_PRODUCTS . " set products_status = '0' where products_id = '" . tep_get_prid($order->products[$i]['id']) . "'");
				  }
				}
			  }
		  
		  // Update products_ordered (for bestsellers list)
			  tep_db_query("update " . TABLE_PRODUCTS . " set products_ordered = products_ordered + " . sprintf('%d', $order->products[$i]['qty']) . " where products_id = '" . tep_get_prid($order->products[$i]['id']) . "'");
		  
			  $sql_data_array = array('orders_id' => $insert_id, 
									  'products_id' => tep_get_prid($order->products[$i]['id']), 
									  'products_model' => $order->products[$i]['model'], 
									  'products_name' => $order->products[$i]['name'], 
									  'products_price' => $order->products[$i]['price'], 
									  'final_price' => $order->products[$i]['final_price'], 
									  'products_tax' => $order->products[$i]['tax'], 
									  'products_quantity' => $order->products[$i]['qty']);
			  tep_db_perform(TABLE_ORDERS_PRODUCTS, $sql_data_array);
			  $order_products_id = tep_db_insert_id();
		  
		  //------insert customer choosen option to order--------
			  $attributes_exist = '0';
			  //$products_ordered_attributes = '';
			  if (isset($order->products[$i]['attributes'])) {
				$attributes_exist = '1';
				for ($j=0, $n2=sizeof($order->products[$i]['attributes']); $j<$n2; $j++) {
				  if (DOWNLOAD_ENABLED == 'true') {
					$attributes_query = "select popt.products_options_name, poval.products_options_values_name, pa.options_values_price, pa.price_prefix, pad.products_attributes_maxdays, pad.products_attributes_maxcount , pad.products_attributes_filename 
										 from " . TABLE_PRODUCTS_OPTIONS . " popt, " . TABLE_PRODUCTS_OPTIONS_VALUES . " poval, " . TABLE_PRODUCTS_ATTRIBUTES . " pa 
										 left join " . TABLE_PRODUCTS_ATTRIBUTES_DOWNLOAD . " pad
										  on pa.products_attributes_id=pad.products_attributes_id
										 where pa.products_id = '" . $order->products[$i]['id'] . "' 
										  and pa.options_id = '" . $order->products[$i]['attributes'][$j]['option_id'] . "' 
										  and pa.options_id = popt.products_options_id 
										  and pa.options_values_id = '" . $order->products[$i]['attributes'][$j]['value_id'] . "' 
										  and pa.options_values_id = poval.products_options_values_id 
										  and popt.language_id = '" . $languages_id . "' 
										  and poval.language_id = '" . $languages_id . "'";
					$attributes = tep_db_query($attributes_query);
				  } else {
					$attributes = tep_db_query("select popt.products_options_name, poval.products_options_values_name, pa.options_values_price, pa.price_prefix from " . TABLE_PRODUCTS_OPTIONS . " popt, " . TABLE_PRODUCTS_OPTIONS_VALUES . " poval, " . TABLE_PRODUCTS_ATTRIBUTES . " pa where pa.products_id = '" . $order->products[$i]['id'] . "' and pa.options_id = '" . $order->products[$i]['attributes'][$j]['option_id'] . "' and pa.options_id = popt.products_options_id and pa.options_values_id = '" . $order->products[$i]['attributes'][$j]['value_id'] . "' and pa.options_values_id = poval.products_options_values_id and popt.language_id = '" . $languages_id . "' and poval.language_id = '" . $languages_id . "'");
				  }
				  $attributes_values = tep_db_fetch_array($attributes);
		  
				  $sql_data_array = array('orders_id' => $insert_id, 
										  'orders_products_id' => $order_products_id, 
										  'products_options' => $attributes_values['products_options_name'],
										  'products_options_values' => $attributes_values['products_options_values_name'], 
										  'options_values_price' => $attributes_values['options_values_price'], 
										  'price_prefix' => $attributes_values['price_prefix']);
				  tep_db_perform(TABLE_ORDERS_PRODUCTS_ATTRIBUTES, $sql_data_array);
		  
				  if ((DOWNLOAD_ENABLED == 'true') && isset($attributes_values['products_attributes_filename']) && tep_not_null($attributes_values['products_attributes_filename'])) {
					$sql_data_array = array('orders_id' => $insert_id, 
											'orders_products_id' => $order_products_id, 
											'orders_products_filename' => $attributes_values['products_attributes_filename'], 
											'download_maxdays' => $attributes_values['products_attributes_maxdays'], 
											'download_count' => $attributes_values['products_attributes_maxcount']);
					tep_db_perform(TABLE_ORDERS_PRODUCTS_DOWNLOAD, $sql_data_array);
				  }
				  $this->products_ordered_attributes .= "\n\t" . $attributes_values['products_options_name'] . ' ' . $attributes_values['products_options_values_name'];
				}
			  }
		  //------insert customer choosen option eof ----
			  $total_weight += ($order->products[$i]['qty'] * $order->products[$i]['weight']);
			  $total_tax += tep_calculate_tax($total_products_price, $products_tax) * $order->products[$i]['qty'];
			  $total_cost += $total_products_price;
		  
			  $this->products_ordered .= $order->products[$i]['qty'] . ' x ' . $order->products[$i]['name'] . ' (' . $order->products[$i]['model'] . ') = ' . $currencies->display_price($order->products[$i]['final_price'], $order->products[$i]['tax'], $order->products[$i]['qty']) . $this->products_ordered_attributes . "\n";
			  $_SESSION['products_ordered'] = $this->products_ordered;
			
			}//End for
			
  }//End function
  
  function send_order_email($order_totals){
	global $currencies;
	$order = new order($_SESSION['insert_id']);
	//p($order);
	// lets start with the email confirmation
	$email_order = STORE_NAME . "\n" . 
				   EMAIL_SEPARATOR . "\n" . 
				   EMAIL_TEXT_ORDER_NUMBER . ' ' . $_SESSION['insert_id'] . "\n" .
				   EMAIL_TEXT_INVOICE_URL . ' ' . tep_href_link(FILENAME_ACCOUNT_HISTORY_INFO, 'order_id=' . $_SESSION['insert_id'], 'SSL', false) . "\n" .
				   EMAIL_TEXT_DATE_ORDERED . ' ' . strftime(DATE_FORMAT_LONG) . "\n\n";
	if ($order->info['comments']) {
	  $email_order .= tep_db_output($order->info['comments']) . "\n\n";
	}
	$email_order .= EMAIL_TEXT_PRODUCTS . "\n" . 
					EMAIL_SEPARATOR . "\n" . 
					$_SESSION['products_ordered'] . 
					EMAIL_SEPARATOR . "\n";
  
	for ($i=0, $n=sizeof($order_totals); $i<$n; $i++) {
	  $email_order .= strip_tags($order_totals[$i]['title']) . ' ' . strip_tags($order_totals[$i]['text']) . "\n";
	}
	
	//SAFEBILL
      if(isset($order->info['safebill_info']['invoicing_costs']) && $order->info['safebill_info']['invoicing_costs'] > 0){
           $email_order .= HEAD_SAFEBILL_INVOICE_FEE . ' ' . $currencies->format($order->info['safebill_info']['invoicing_costs'],true) . "\n";
      }
      if(isset($order->info['safebill_info']['partial_payment_fees']) && $order->info['safebill_info']['partial_payment_fees'] > 0){
         $email_order.= HEAD_SAFEBILL_PARTIAL_PAYMENT_FEE . ' ' . $currencies->format($order->info['safebill_info']['partial_payment_fees'],true) . "\n";
      }
      if($order->info['safebill_info']['invoicing_costs'] > 0 || $order->info['safebill_info']['partial_payment_fees'] > 0){
        $email_order.= HEAD_SAFEBILL_COMPLETE_TOTAL . ' ' . $currencies->format($order->info['safebill_info']['order_total_with_safebill'],true) . "\n\n";
      }
	  
	  if(isset($order->info['safebill_info']['partial_payment_table']) && sizeof($order->info['safebill_info']['partial_payment_table']) > 0){
		$email_order .= ENTRY_SAFEBILL_MODALITY . "\n" .
						EMAIL_SEPARATOR . "\n";
		
		foreach($order->info['safebill_info']['partial_payment_table'] as $key => $value){
			$key++;
			$email_order .= $key . ' : ' . $value['payment_date'] . ' ' . $currencies->format($value['payment_amount'],true, $order->info['currency'], $order->info['currency_value']) . "\n";
		}					
	  }				  
    //SAFEBILL
  
	if ($order->content_type != 'virtual') {
	  $email_order .= "\n" . EMAIL_TEXT_DELIVERY_ADDRESS . "\n" . 
					  EMAIL_SEPARATOR . "\n" .
					  tep_address_label($_SESSION['customer_id'], $_SESSION['sendto'], 0, '', "\n") . "\n";
	}
  
	$email_order .= "\n" . EMAIL_TEXT_BILLING_ADDRESS . "\n" .
					EMAIL_SEPARATOR . "\n" .
					tep_address_label($_SESSION['customer_id'],  $_SESSION['billto'], 0, '', "\n") . "\n\n";
	  $email_order .= EMAIL_TEXT_PAYMENT_METHOD . "\n" . 
					  EMAIL_SEPARATOR . "\n";
	  
	  $email_order .= $order->info['payment_method'] . "\n\n";
	  $email_order .= $payment_class->email_footer . "\n\n";
	//}
	tep_mail($order->customer['firstname'] . ' ' . $order->customer['lastname'], $order->customer['email_address'], EMAIL_TEXT_SUBJECT, $email_order, STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);
  
  // send emails to other people
	if (SEND_EXTRA_ORDER_EMAILS_TO != '') {
	  tep_mail('', SEND_EXTRA_ORDER_EMAILS_TO, EMAIL_TEXT_SUBJECT, $email_order, STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);
	}
  }
  
  function after_process() {
        return false;
  }

  function get_error() {
      global $_GET;

      if (isset($_GET['ErrMsg']) && tep_not_null($_GET['ErrMsg'])) {
        $error = stripslashes(urldecode($_GET['ErrMsg']));
      } elseif (isset($_GET['Err']) && tep_not_null($_GET['Err'])) {
        $error = stripslashes(urldecode($_GET['Err']));
      } elseif (isset($_GET['error']) && tep_not_null($_GET['error'])) {
        $error = stripslashes(urldecode($_GET['error']));
      } else {
        $error = MODULE_PAYMENT_SAFEBILLOSC_TEXT_ERROR_MESSAGE;
      }
	  echo $error;

      return array('title' => MODULE_PAYMENT_SAFEBILLOSC_TEXT_ERROR,
                   'error' => $error);
    }

  function output_error() {
    return false;
  }

  function check() {
    if (!isset($this->check)) {
      $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION
			                          . " where configuration_key = 'MODULE_PAYMENT_SAFEBILLOSC_STATUS'");
      $this->check = tep_db_num_rows($check_query);
    }
	
    return $this->check;
  }

  function install() {
	
    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value"
		                                                  . ", configuration_description, configuration_group_id, sort_order"
																											. ", set_function, date_added)"
							. " values ('Safebill payment status', 'MODULE_PAYMENT_SAFEBILLOSC_STATUS', 'True', 'Activate payment method'"
							       . ", '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");

    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value"
		                                                  . ", configuration_description, configuration_group_id, sort_order"
																											. ", date_added)"
							. " values ('Merchant ID', 'MODULE_PAYMENT_SAFEBILLOSC_ID', '1000011011'"
							       . ", 'Merchant identifier', '6', '2', now())");
	
	tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value"
		                                                  . ", configuration_description, configuration_group_id, sort_order"
																											. ", date_added)"
							. " values ('Merchant password', 'MODULE_PAYMENT_SAFEBILLOSC_PASSWD', 'aaaaaaaa'"
							       . ", 'Merchant Password', '6', '2', now())");
	
	tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value"
		                                                  . ", configuration_description, configuration_group_id, sort_order"
																											. ", date_added)"
							. " values ('Shop ID', 'MODULE_PAYMENT_SAFEBILLOSC_SHOP_ID', '111111111'"
							       . ", 'Shop identifier', '6', '2', now())");
	
	tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value"
		                                                  . ", configuration_description, configuration_group_id, sort_order"
																											. ", date_added)"
							. " values ('SHA Sign', 'MODULE_PAYMENT_SAFEBILLOSC_SHASIGN', 'xxxxxxxx'"
							       . ", 'Private key', '6', '2', now())");

    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value"
		                                                  . ", configuration_description, configuration_group_id, sort_order"
																											. ", date_added)"
							. " values ('Success page', 'MODULE_PAYMENT_SAFEBILLOSC_SUCCESS_URL', 'http://www.yourdomain.com/checkout_process.php?notify=true', 'La page de retour en cas de success.'"
							       . ", '6', '2', now())");

    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value"
		                                                  . ", configuration_description, configuration_group_id, sort_order"
																											. ", date_added)"
							. " values ('Error page', 'MODULE_PAYMENT_SAFEBILLOSC_ERROR_URL', 'http://www.yourdomain.com/checkout_process.php?notify=true', 'La page de retour en cas d\'erreur.'"
							       . ", '6', '2', now())");

    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value"
		                                                  . ", configuration_description, configuration_group_id, sort_order"
																											. ", date_added)"
							. " values ('Cancel page', 'MODULE_PAYMENT_SAFEBILLOSC_CANCEL_URL', 'http://www.yourdomain.com/checkout_process.php?notify=true', 'La page de retour en cas d\'annulation.'"
							       . ", '6', '2', now())");

    tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value"
		                                                  . ", configuration_description, configuration_group_id, sort_order"
																											. ", set_function, date_added)"
							. " values ('Mode', 'MODULE_PAYMENT_SAFEBILLOSC_MODE', 'Test', 'Mode test (service disabled)'"
							       . ", '6', '3', 'tep_cfg_select_option(array(\'Test\', \'Real\'), ', now())");
	
	tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value"
		                                                  . ", configuration_description, configuration_group_id, sort_order"
																											. ", set_function, date_added)"
							. " values ('Validation type', 'MODULE_PAYMENT_SAFEBILLOSC_VALIDATION_TYPE', 'Manual', 'Validation type'"
							       . ", '6', '3', 'tep_cfg_select_option(array(\'manual\', \'auto\'), ', now())");
	
	tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value"
														. ", configuration_description, configuration_group_id, sort_order"
														. ", use_function, set_function, date_added) "
							. " values ('Zone de paiement', 'MODULE_PAYMENT_SAFEBILLOSC_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.'"
							. ", '6', '2', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
	
	tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value"
														. ", configuration_description, configuration_group_id, sort_order, date_added) "
							. " values ('Sort order of display.', 'MODULE_PAYMENT_SAFEBILLOSC_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.'"
							. ", '6', '0', now())");
	
	tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value"
							. ", configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) "
							." values ('Set Order Status', 'MODULE_PAYMENT_SAFEBILLOSC_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
	
	//Payment surcharge
	tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value"
		                                                  . ", configuration_description, configuration_group_id, sort_order"
																											. ", date_added)"
							. " values ('Payment surcharge percent', 'MODULE_PAYMENT_SAFEBILLOSC_SURCHARGE_PERCENT', '0'"
							       . ", 'Set percentage of total amount', '6', '2', now())");
	
	tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value"
		                                                  . ", configuration_description, configuration_group_id, sort_order"
																											. ", date_added)"
							. " values ('Payment surcharge fix amount', 'MODULE_PAYMENT_SAFEBILLOSC_SURCHARGE_AMOUNT', '0'"
							       . ", 'Set a fix amount value', '6', '2', now())");

	//Add Safebill Order statuses
	$statuses = array('Safebill Cancel','Safebill Failed','Safebill Open','Safebill Completed');
	foreach($statuses as $status){
		$languages = tep_get_languages();
		$next_id_query = tep_db_query("select max(orders_status_id) as orders_status_id from " . TABLE_ORDERS_STATUS . "");
            $next_id = tep_db_fetch_array($next_id_query);
            $orders_status_id = $next_id['orders_status_id'] + 1;
		for ($i=0; $i<sizeof($languages); $i++) {
			
			tep_db_query("INSERT INTO " . TABLE_ORDERS_STATUS. " (orders_status_id,language_id, orders_status_name, public_flag, downloads_flag)"
								." VALUES (".$orders_status_id.", ".$languages[$i]['id'].", '".$status."', '1', '0');");
			}
	}
	// create DB table for store of partial payment
		$query_raw = "CREATE TABLE IF NOT EXISTS " .TABLE_SAFEBILL_PARTIAL_PAYMENT_TABLE. " (`orders_id` int(10) NOT NULL DEFAULT '0',`amount` decimal(12,2) NOT NULL DEFAULT '0.00',`date` varchar(64) NOT NULL, `timestamp` int(11) NOT NULL) ENGINE=MyISAM DEFAULT CHARSET=utf8";
		tep_db_query($query_raw);
		// create DB table to store partial payment
		$query_raw = "CREATE TABLE IF NOT EXISTS " . TABLE_SAFEBILL_PAYMENT_RESULTS . " (`result_id` INT( 10 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,`orders_id` INT( 10 ) NOT NULL ,`result` TEXT NOT NULL) ENGINE = MYISAM DEFAULT CHARSET=utf8";
		tep_db_query($query_raw);
		if(!$this->db_field_exist('sb_invoicing_costs',TABLE_ORDERS)){
			$query_row = "ALTER TABLE " . TABLE_ORDERS. " ADD `sb_invoicing_costs` DECIMAL( 12, 2 ) NOT NULL ;";
			tep_db_query("$query_row");
		}
		
		if(!$this->db_field_exist('sb_partial_payment_fees',TABLE_ORDERS)){
			$query_row = "ALTER TABLE " . TABLE_ORDERS. " ADD `sb_partial_payment_fees` DECIMAL( 12, 2 ) NOT NULL ;";
			tep_db_query("$query_row");
		}
		
		$query_row = "ALTER TABLE " . TABLE_CUSTOMERS. " ADD `sb_user_id` INT( 100 ) NULL";
		tep_db_query("$query_row");
		
		$query_row = "ALTER TABLE " . TABLE_ORDERS_HISTORY_STATUS. " ADD `sb_return_status` VARCHAR( 128 ) CHARACTER SET utf8 COLLATE utf8_bin NULL ;";		
		tep_db_query("$query_row");

  }
  
  function db_field_exist($field,$table_name){
	$column_query = tep_db_query("SHOW COLUMNS FROM ".$table_name."  FROM ".DB_DATABASE.";");
	while($res = tep_db_fetch_array($column_query)){
		$column[] = $res['Field'];
	}
	if(in_array($field,$column)){
		return true;
	}else{
		return false;
	}
  }

  function remove() {
    tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_SAFEBILLOSC_STATUS'");
    tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_SAFEBILLOSC_ID'");
	tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_SAFEBILLOSC_PASSWD'");
	tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_SAFEBILLOSC_SHOP_ID'");
    tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_SAFEBILLOSC_SHASIGN'");
    tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_SAFEBILLOSC_SUCCESS_URL'");
    tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_SAFEBILLOSC_ERROR_URL'");
	tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_SAFEBILLOSC_CANCEL_URL'");
	tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_SAFEBILLOSC_MODE'");
	tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_SAFEBILLOSC_VALIDATION_TYPE'");
	tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_SAFEBILLOSC_SORT_ORDER'");
	tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_SAFEBILLOSC_ZONE'");
	tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_SAFEBILLOSC_ORDER_STATUS_ID'");
	
	tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_SAFEBILLOSC_SURCHARGE_PERCENT'");
	tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_SAFEBILLOSC_SURCHARGE_AMOUNT'");
	
	tep_db_query("ALTER TABLE " . TABLE_CUSTOMERS . " DROP `sb_user_id`");
	
	//Uncomment if you want to remove these 2 columns
	//tep_db_query("ALTER TABLE " . TABLE_ORDERS . " DROP `sb_invoicing_costs`");
	//tep_db_query("ALTER TABLE " . TABLE_ORDERS . " DROP `sb_partial_payment_fees`");
  }

  function keys() {
    return array('MODULE_PAYMENT_SAFEBILLOSC_STATUS', 'MODULE_PAYMENT_SAFEBILLOSC_ID', 'MODULE_PAYMENT_SAFEBILLOSC_PASSWD'
		           , 'MODULE_PAYMENT_SAFEBILLOSC_SHOP_ID', 'MODULE_PAYMENT_SAFEBILLOSC_SHASIGN'
				   , 'MODULE_PAYMENT_SAFEBILLOSC_SUCCESS_URL', 'MODULE_PAYMENT_SAFEBILLOSC_ERROR_URL','MODULE_PAYMENT_SAFEBILLOSC_CANCEL_URL'
				   , 'MODULE_PAYMENT_SAFEBILLOSC_MODE', 'MODULE_PAYMENT_SAFEBILLOSC_VALIDATION_TYPE', 'MODULE_PAYMENT_SAFEBILLOSC_SORT_ORDER'
				   , 'MODULE_PAYMENT_SAFEBILLOSC_ZONE', 'MODULE_PAYMENT_SAFEBILLOSC_ORDER_STATUS_ID', 'MODULE_PAYMENT_SAFEBILLOSC_SURCHARGE_PERCENT'
				   , 'MODULE_PAYMENT_SAFEBILLOSC_SURCHARGE_AMOUNT');
  }
}
?>